<template>
  <div class="cont">
    <el-container style="height:100%">
      <appBar />
      <sideDrawer />
      <el-container>
        <el-main style="margin-left:-100px">
          <el-card class="a">
            <!-- <v-card-title>用户设置</v-card-title>
            <v-card-subtitle>欢迎来到你的个性化世界！</v-card-subtitle>-->
            <div class="card-title">用户设置</div>
            <div class="card-subtitle">欢迎来到你的个性化世界！</div>
            <el-row>
              <el-col span="12">
                <v-text-field label="昵称" class="card-item" dense v-model="nickName"></v-text-field>
                <v-select
                  label="头像颜色"
                  class="card-item"
                  dense
                  :items="avatarColors"
                  v-model="colorChosen"
                ></v-select>
                <v-text-field label="头像图标" class="card-item" dense v-model="avatar"></v-text-field>
                <v-subheader>
                  *注：图标列表可参见
                  <a href="https://cdn.materialdesignicons.com/4.8.95/">material design icons官网</a>，右击获取。
                </v-subheader>
                <div class="rightcont">
                  <el-button type="primary" plain @click="savechange" class="btn">更新</el-button>
                </div>
              </el-col>
              <el-col span="12">
                <v-sheet tile color="white" width="150" height="150" class="sheet">
                  <v-subheader>目前头像：</v-subheader>
                  <v-avatar :color="colorChosen" class="avatar">
                    <v-icon x-large color="white">{{ avatar }}</v-icon>
                  </v-avatar>
                </v-sheet>
              </el-col>
            </el-row>
          </el-card>
        </el-main>
      </el-container>
    </el-container>
  </div>
</template>

<script>
import appBar from "../basic/appBar";
import sideDrawer from "../basic/sideDrawer";
//import getUser from './getUser'
export default {
  name: "UserPage",
  components: {
    appBar,
    sideDrawer //, getUser
  },
  data: () => ({
    userName: "",
    nickName: "",
    colorChosen: "",
    avatar: "",
    avatarColors: [
      { text: "正红", value: "red" },
      { text: "浓粉", value: "pink" },
      { text: "紫色", value: "purple" },
      { text: "蓝紫", value: "deep-purple" },
      { text: "靛蓝", value: "indigo" },
      { text: "湖蓝", value: "blue" },
      { text: "天蓝", value: "light-blue" },
      { text: "青蓝", value: "cyan" },
      { text: "青绿", value: "teal" },
      { text: "果绿", value: "green" },
      { text: "草绿", value: "light-green" },
      { text: "绿黄", value: "lime" },
      { text: "正黄", value: "yellow" },
      { text: "琥珀", value: "amber" },
      { text: "橙色", value: "orange" },
      { text: "橘红", value: "deep-orange" },
      { text: "棕色", value: "brown" },
      { text: "蓝灰", value: "blue-grey" },
      { text: "银灰", value: "grey" }
    ]
  }),
  methods: {
    savechange() {
      // validate
      if (this.nickName === "") {
        alert("昵称不能为空，请输入");
        return;
      }

      if (this.avatar === "") {
        alert("头像不能为空，请输入");
        return;
      }

      if (this.colorChosen === "") {
        alert("用户颜色不能为空，请输入");
        return;
      }

      this.$axios({
        method: "post",
        url: `/updateUser`,
        data: {
          userName: this.userName,
          nickName: this.nickName,
          color: this.colorChosen,
          avatar: this.avatar
        }
      }).then(res => {
        if (res.status === 200) {
          const data = res.data;
          if (data.status === "UPDATE_SUCCESS") {
            sessionStorage.setItem("nickName", this.nickName);
            sessionStorage.setItem("userAvatar", this.avatar);
            sessionStorage.setItem("userColor", this.colorChosen);

            // this.$store.dispatch("setNickName", this.nickName);
            // this.$store.dispatch("setUserAvatar", this.avatar);
            // this.$store.dispatch("setUserColor", this.colorChosen);
            this.$evtbus.$emit("User.UserInfoUpdated");
            alert("修改成功");
          } else {
            alert("出错了！");
          }
          return;
        }

        alert("连接失败。\n请检查您的网络状态。");
      });
    }
  },
  mounted() {
    this.userName = this.$store.getters.userName;
    this.nickName = this.$store.getters.nickName;
    this.avatar = this.$store.getters.userAvatar;
    this.colorChosen = this.$store.getters.userColor;
  }
};
</script>

<style scoped>
.cont {
  /* background-color: #f8ffaa; */
  background-color: #eeeeee;
  height: 100%;
  width: 100%;
}
.a {
  margin-top: 10%;
  margin-left: 25%;
  width: 50%;
  height: 50%;
  min-height:450px;
  min-width:600px;
  /* background-color: #7effbf; */
  background-color: #fafafa;
}
.rightcont {
  display: flex;
  justify-content: flex-end;
}
.card-title {
    font-size: 34px;
    color: #3f92d2;
}
.card-subtitle {
    font-size: 16px;
    margin-top: 10px;
    margin-left: 2px;
    color: #3f92d2;
}
.card-item{
    margin-top: 15px;
    margin-left: 20px;
}
.sheet{
    margin-left: 40%;
    margin-top:10%;
}
.avatar{
    margin-left: 35%;
    margin-top:7%;
}
.btn{
    width: 100%;
    margin-top: 20px;
    margin-left: 20px;
}
</style>
